"""
    This is sample python code to send a credit card transaction to TGATE's Payment Gateway.
    It uses an HTTP POST or HTTP GET approach to send the appropriate information to the gateway.
    HTTP GET sends the url and data together with a ? between the two along with the header info,
    HTTP POST sends the url, data and headers as separate elements

    See notes below to implement either method.  It can be integrated with a web-form as well
    by using the CGI library and the cgitb to debug -- the code is commented out below.

    For questions about this sample code or other sample code available with TGATE's Payment Gateway
    SDK, email developersupport@tgatepayments.com.
    
"""
import urllib
import urllib2
from xml.dom import minidom

""" uncomment the following section to retrieve values from a form and
comment/delete the section where I am setting the variable values myself.
You will also need to create an HTML form with the appropriate field names
and call this script in the action= statement.

For more info on accessing form data go to
http://python.about.com/od/cgiformswithpython/ss/pycgitut1.htm
or visit other such resources on the web.

import cgi  #to use data from forms
import cgitb  #for error checking with forms

form = cgi.FieldStorage()
user = form.getvalue('UserName')
pw = form.getvalue('Password')
trans = form.getvalue('TransType')
card = form.getvalue('CardNum')
expires = form.getvalue('ExpDate')
mag = form.getvalue('MagData')
name = form.getvalue('NameOnCard')
amt = form.getvalue('Amount')
inv = form.getvalue('InvNum')
pnref = form.getvalue('PNRef')
zip = form.getvalue('Zip')
street = form.getvalue('Street')
cv = form.getvalue('CVNum')
ext = form.getvalue('ExtData')
"""

user = 'xxxx'
pw = 'xxxx'
trans = 'Sale' #restrict ecommerce transaction types to Sale, perform refund, void through the Virtual Terminal 
card = 'xxxxx'
expires = 'xxxx' #in mmyy format
mag = ''
name = ''  #required
amt = ''  #in dollars.cents format as string, can be dollars if no cents
inv = ''  #invoice number with no ctrl characters or dashes
pnref = ''
zipcode = ''  #required for ecommerce security
street = '' #required for ecommerce security
cv = ''   #required for ecommerce security
ext = ''

gateway_url = 'https://gatewaystage.itstgate.com/SmartPayments/transact.asmx/ProcessCreditCard'
values = {'UserName' : user,
          'Password' : pw,
          'TransType' : trans,
          'CardNum' : card,
          'ExpDate' : expires,
          'MagData' : mag,
          'NameOnCard' : name,
          'Amount' : amt,
          'InvNum' : inv,
          'PNRef' : pnref,
          'Zip' : zipcode,
          'Street' : street,
          'CVNum' : cv,
          'ExtData' : ext}

txndata = urllib.urlencode(values)

headers = {'User-Agent' : 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)'}

get_url = gateway_url + '?' + txndata  #strings appended for HTTP GET

# req = urllib2.Request(url=get_url, headers=headers) #un-comment for HTTP GET
req = urllib2.Request(url=gateway_url, data=txndata, headers=headers) #un-comment for HTTP POST

urllib2.build_opener(urllib2.HTTPHandler(debuglevel=1))

try:
    handle = urllib2.urlopen(req)
except IOError, e:
    if hasattr(e, 'reason'):
        print 'We failed to reach a server.'
        print 'Reason: ', e.reason
        print e.info()
    elif hasattr(e, 'code'):
        print 'The server couldn\'t fulfill the request.'
        print 'Error code: ', e.code
        print e.info()
else:
    the_page = handle.read()
    # print the_page  #displays the xml result

    # convert the HTML back into plain XML
    for entity, char in (('lt', '<'), ('gt', '>'), ('amp', '&')):
        the_page = the_page.replace('&%s;' % entity, char)

        # clean some cruft... XML won't parse with this stuff in there...
        the_page = the_page.replace(' xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="SmartPayments"', '')
        the_page = the_page.replace('<?xml version="1.0" encoding="utf-8"?>\r\n', '')
        
        # parse the cleaned XML
        dom = minidom.parseString(the_page)
        children = dom.getElementsByTagName('Response')[0]
        
        # extract the interesting parts
        ResultCode = children.getElementsByTagName('Result')[0].firstChild.data
        RespMessage = children.getElementsByTagName('RespMSG')[0].firstChild.data


maskedcard = card[12:]
for i in range(len(maskedcard), len(card),1): maskedcard = "*" + maskedcard

        # print to web form
print "TRANSACTION RESULT" + "\r\n"
print 'Customer: ' + name + "\r\n"  #name on card
print 'Sale Amount: ' + amt + "\r\n"  # amount
print 'Card #: ' + maskedcard + "\r\n"
print "Result:  " + ResultCode + "\r\n"    
print "Response:  " + RespMessage + "\r\n"    

if ResultCode == "0":
    Message = children.getElementsByTagName('Message')[0].firstChild.data
    AuthCode = children.getElementsByTagName('AuthCode')[0].firstChild.data
    PNRef = children.getElementsByTagName('PNRef')[0].firstChild.data
    if children.getElementsByTagName('GetAVSResult')[0].firstChild.data == True:
      AVSResult = children.getElementsByTagName('GetAVSResult')[0].firstChild.data
      AVSResultTxt = children.getElementsByTagName('GetAVSResultTXT')[0].firstChild.data
      StreetMatch = children.getElementsByTagName('GetStreetMatchTXT')[0].firstChild.data
      ZipMatch = children.getElementsByTagName('GetZipMatchTXT')[0].firstChild.data
    if children.getElementsByTagName('GetCVResult')[0].firstChild.data == True:
      CVSResult = children.getElementsByTagName('GetCVResult')[0].firstChild.data
      CVSResultTxt = children.getElementsByTagName('GetCVResultTXT')[0].firstChild.data
    CommercialCard = children.getElementsByTagName('GetCommercialCard')[0].firstChild.data
    ExtData = children.getElementsByTagName('ExtData')[0].firstChild.data
    mydata = ExtData.split(",",3)
    InvNum = mydata[0].replace('=',":  ")
    CardType = mydata[1].replace('=',":  ")
    BatchNum = mydata[2].replace('=',":  ")

    print "Message:  " + Message + "\r\n"
    print "AuthCode:  " + AuthCode + "\r\n"
    if AVSResult != '':  
      print "AVS Result:  " + AVSResult + " " + AVSResultTxt + "\r\n"    
    if CVSResult != '':  
      print "CVS Result:  " + CVSResult + " " + CVSResultTxt + "\r\n"
    # and continue to print the rest of the data for your receipt        
    # and of course provide other processing if resultcode != 0 if you want

    
